IR.AddListener(IR.EVENT_START, 0, function () {
   IR.ShowPopup("Popup 2");
   var dataSetup = new dataClass();
	var bticino_create;
   
   //Названия граф. элементов, которые можно поменять!!!
   var main = IR.GetItem("Popup 2");
   var value_graf = main.GetItem("value");
   var up_graf = main.GetItem("up bg plus 88x64");
   var down_graf = main.GetItem("down bg minus 88x64");
   /////////////////////////////////////////////////////
   
	if (!__bticino)
		var __bticino = {};
	if (!__bticino[dataSetup.m_data.HOST]) {
		IR.Log("__bticino create")
		__bticino[dataSetup.m_data.HOST] = {};
		bticino_create = true;
		__bticino[dataSetup.m_data.HOST].autore = function (in_str) {
			if (in_str.length < 5) {
				return false;
			}
			if (in_str.substring(0, 2) != "*#") {
				return false;
			}
			if (in_str.substring(in_str.length - 2, in_str.length) != "##") {
				return false;
			}
			if (in_str.substring(2, in_str.length - 4) == 0) {
				return false;
			}
			if (in_str.substring(2, 6).indexOf("*") != -1 || in_str.substring(2, 6).indexOf("#") != -1) {
				return false;
			}
			return true;
		}
		__bticino[dataSetup.m_data.HOST].ApplicaAlgoritmo = function (in_device, in_pass, in_nonce) {
			var flag = true;
			var num1 = 0x0;
			var num2 = 0x0;
			var password = parseInt(in_pass, 10);
			for (var c in in_nonce) {
				c = in_nonce[c];
				if (c != '0') {
					if (flag)
						num2 = password;
					flag = false;
				}
				switch (c) {
				case '1':
					num1 = num2 & 0xFFFFFF80;
					num1 = num1 >>> 7;
					num2 = num2 << 25;
					num1 = num1 + num2;
					break;
				case '2':
					num1 = num2 & 0xFFFFFFF0;
					num1 = num1 >>> 4;
					num2 = num2 << 28;
					num1 = num1 + num2;
					break;
				case '3':
					num1 = num2 & 0xFFFFFFF8;
					num1 = num1 >>> 3;
					num2 = num2 << 29;
					num1 = num1 + num2;
					break;
				case '4':
					num1 = num2 << 1;
					num2 = num2 >>> 31;
					num1 = num1 + num2;
					break;
				case '5':
					num1 = num2 << 5;
					num2 = num2 >>> 27;
					num1 = num1 + num2;
					break;
				case '6':
					num1 = num2 << 12;
					num2 = num2 >>> 20;
					num1 = num1 + num2;
					break;
				case '7':
					num1 = num2 & 0x0000FF00;
					num1 = num1 + ((num2 & 0x000000FF) << 24);
					num1 = num1 + ((num2 & 0x00FF0000) >>> 16);
					num2 = (num2 & 0xFF000000) >>> 8;
					num1 = num1 + num2;
					break;
				case '8':
					num1 = num2 & 0x0000FFFF;
					num1 = num1 << 16;
					num1 = num1 + (num2 >>> 24);
					num2 = num2 & 0x00FF0000;
					num2 = num2 >>> 8;
					num1 = num1 + num2;
					break;
				case '9':
					num1 = ~num2;
					break;
				case '0':
					num1 = num2;
					break;
				}
				num2 = num1;
			}
			in_device.Send(["*#" + (num1 >>> 0).toString() + "##"]);
		}
		__bticino[dataSetup.m_data.HOST].logIn = function (in_device, in_text) {
			var pass = 741852;
			var str = in_text.substring(2, in_text.length - 2).split('');
			if (__bticino[dataSetup.m_data.HOST].autore(in_text)) {
				__bticino[dataSetup.m_data.HOST].ApplicaAlgoritmo(in_device, pass, str);
			}
		}
		__bticino[dataSetup.m_data.HOST].devices = [];
		__bticino[dataSetup.m_data.HOST].listOnline = function (in_device, in_command) {
			for (var i = 0; i < 3; i++)
				if (__bticino[dataSetup.m_data.HOST].devices[i] == in_device) {
					return false
				} else {
					if (i == 2)
						IR.AddListener(IR.EVENT_ONLINE, in_device, function () {
							in_device.Send([in_command]);
						})
						__bticino[dataSetup.m_data.HOST].devices.push(in_device)
				}
		}
      
	} else {
		bticino_create = false;
	}

	var where;
	
	var Interface = dataSetup.m_data.INTERFACE == "Private riser" ? "" : ("#4#" + dataSetup.m_data.INTERFACE);
	switch (dataSetup.m_data.TYPE_ADDRESS) {
	case 0:
		where = "0" + Interface;
		value_graf.Visible = false;
		main.Height = 180;
		up_graf.X = up_graf.X - 20;
		down_graf.X = down_graf.X + 20;
		break;
	case "Area":
		where = dataSetup.m_data.AREA + Interface;
		value_graf.Visible = false;
		main.Height = 180;
		up_graf.X = up_graf.X - 20;
		down_graf.X = down_graf.X + 20;
		break;
	case "Group":
		where = "#" + dataSetup.m_data.GROUP + Interface;
		value_graf.Visible = false;
		main.Height = 180;
		up_graf.X = up_graf.X - 20;
		down_graf.X = down_graf.X + 20;
		break;
	case "Point to point":
		where = dataSetup.m_data.AREA + dataSetup.m_data.POINT + Interface;
		break;
	}
	IR.SetVariable("Global.lightStatus", 0)
	var device0 = IR.GetDevice("bticino0");
	device0.SetParameters({
		ReceiveWaitTimeMax : 0
	});
	var device = device0;
   
	var light = 0;
	var i = 0;
	if (bticino_create) {
		__bticino[dataSetup.m_data.HOST].listOnline(device0, "*99*0##")
		IR.AddListener(IR.EVENT_RECEIVE_TEXT, device0, function (in_text) {
			__bticino[dataSetup.m_data.HOST].logIn(device0, in_text)
		})
	}
	var device1 = IR.GetDevice("bticino1_" + dataSetup.m_data.HOST);
	if ((device1 == null)) {
		device1 = IR.CreateDevice(IR.DEVICE_CUSTOM_TCP, // Тип драйвера
				"bticino1_" + dataSetup.m_data.HOST, // Имя
				dataSetup.m_data.HOST, // IP-адрес
				dataSetup.m_data.PORT,
				IR.ALWAYS_CONNECTED, // Драйвер всегда остается подключенным
				IR.SCRIPT_ONLY, // Команды можно отправлять через скрипт
				IR.BACKGROUND_ON);
		device1.Connect();
		device1.AddChannel("Command", 0);
		device1.AddChannel("Feedback", 0);
		__bticino[dataSetup.m_data.HOST].listOnline(device1, "*99*1##")
		IR.AddListener(IR.EVENT_RECEIVE_TEXT, device1, function (in_text) {
			__bticino[dataSetup.m_data.HOST].logIn(device1, in_text)
		})
	} else {
		device1.Connect();
	}
	
	this.lightStatus = 0;
	var receive = function (in_text) {
		var inf = in_text.split("*");
		if (inf[1] == "1" && (inf[3].replace("##", "") == where || inf[3].replace("##", "") == dataSetup.m_data.AREA + Interface || inf[3].replace("##", "") == 0)) {
			if (inf[2] == "0") {
				IR.SetVariable("Global.lightStatus", Number(inf[2]));
            device0.SetFeedback("VALUE", 0);
            device0.SetFeedback("ON_OFF", 0);
				this.lightStatus = 0;
			} else {
				if (inf[2] == "1") {
					IR.SetVariable("Global.lightStatus", Number(inf[2]));
					this.lightStatus = 1;
               var req = "*#1*" + where + "##";
               device0.Send([req]);
				} else {
					if (inf[2] == "30" || inf[2] == "31") {
                  var req = "*#1*" + where + "##";
                  device0.Send([req]); 
						return;
					}
					if (parseInt(inf[2], 10) > 1 && parseInt(inf[2], 10) <= 10) {
                  device0.SetFeedback("VALUE", inf[2] + "0");
                  device0.SetFeedback("ON_OFF", 1);
						IR.SetVariable("Global.lightStatus", Number(inf[2] + 0));
						this.lightStatus = 1;
					}
				}

			}

		}
	}
   IR.AddListener(IR.EVENT_CHANNEL_SET, device0, function (in_name, in_value) {
         if (in_name == "ON_OFF"){
            var req = "*1*" + in_value + "*" + where + "##";
            device0.Send([req])   
         }
         if (in_name == "UP"){
            var req = "*1*" + 30 + "*" + where + "##";
            device0.Send([req]) 
         }
         if (in_name == "DOWN"){
            var req = "*1*" + 31 + "*" + where + "##";
            device0.Send([req]) 
      		if (value_graf.Value == 20){
      			var req = "*1*" + 0 + "*" + where + "##";
               device0.Send([req])
            }  
         }
	});

	IR.AddListener(IR.EVENT_RECEIVE_TEXT, device1, function (text) {
		if (!__bticino[dataSetup.m_data.HOST].autore(text))
			receive(text)
	})
   var request = "*#1*" + where + "##";
   device0.Send([request]); 
	IR.SetInterval(45 * 1000, function () {
		device.Send(["*#1*" + where + "##"]);
	})
	IR.SetTimeout(5000, function () {
		device.Send(["*#1*" + where + "##"]);
	})

});
